const AWS = require('aws-sdk'); // eslint-disable-line import/no-extraneous-dependencies

class Db {
  constructor(config = {}) {
    var service = new AWS.DynamoDB(config = { region: 'us-east-1' });
    this.client = new AWS.DynamoDB.DocumentClient({ service });
  }

  scan(params) {
    return new Promise((resolve, reject) => this.client.scan(params).promise().then(data => resolve(data.Items)).catch(err => reject(err)));
  }

  getItem(params) {
    return new Promise((resolve, reject) => this.client.get(params).promise().then(data => resolve(data.Item)).catch(err => reject(err)));
  }

  createItem(params) {
    return new Promise((resolve, reject) => this.client.put(params).promise().then(() => resolve(params.Item)).catch(err => reject(err)));
  }

  updateItem(params, args) {
    return new Promise((resolve, reject) => this.client.update(params).promise().then(() => resolve(args)).catch(err => reject(err)));
  }

  deleteItem(params, args) {
    return new Promise((resolve, reject) => this.client.delete(params).promise().then(() => resolve(args)).catch(err => reject(err)));
  }

}
module.exports = Db;