const _ = require('lodash');

function scan(params) {
  return new Promise((resolve, reject) => this.client.scan(params).promise().then(data => resolve(data.Items)).catch(err => reject(err)));
}

function getItem(params) {
  return new Promise((resolve, reject) => this.client.get(params).promise().then(data => resolve(data.Item)).catch(err => reject(err)));
}

function createItem(params) {
  return new Promise((resolve, reject) => this.client.put(params).promise().then(() => resolve(params.Item)).catch(err => reject(err)));
}

function updateItem(params, args) {
  return new Promise((resolve, reject) => this.client.update(params).promise().then(() => resolve(args)).catch(err => reject(err)));
}

function deleteItem(params, args) {
  return new Promise((resolve, reject) => this.client.delete(params).promise().then(() => resolve(args)).catch(err => reject(err)));
}

module.exports = client => ({
  client: client,
  scan: scan,
  getItem: getItem,
  createItem: createItem,
  updateItem: updateItem,
  deleteItem: deleteItem
});