var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

const createExpression = rest => Object.keys(rest).map(key => `#${key} = :${key}`).join(', ');

function prependObjectKeys(obj, char, mapToValues = false) {
  return Object.keys(obj).reduce((acc, key) => {
    if (key !== '__typename') {
      acc[`${char}${key}`] = mapToValues ? obj[key] : key;
    }
    return acc;
  }, {});
}

const mapAttributes = rest => ({
  ExpressionAttributeNames: _extends({}, prependObjectKeys(rest, '#', false)),
  ExpressionAttributeValues: _extends({}, prependObjectKeys(rest, ':', true))
});

const createFilterExpression = rest => ({
  FilterExpression: createExpression(rest)
});

module.exports = {
  createExpression,
  prependObjectKeys,
  mapAttributes,
  createFilterExpression
};